/******************************************************************************

    $Id: msg.c,v 1.2 2003/08/28 19:12:27 mmp Exp $
    $Source: /archive/cvs/cc/src/cc/cpp/msg.c,v $

******************************************************************************/

#include "priv.h"


void cpp_msg_new(CPP* cpp)
{
    cpp_buffer_clear(&cpp->msg_buf);
}


void cpp_msg_newfl(CPP* cpp, const char* file, int line)
{
    cpp_msg_new(cpp);
    cpp_msg_catfl(cpp, file, line);
    cpp_msg_catc(cpp, ' ');
}


void cpp_msg_catc(CPP* cpp, char ch)
{
    cpp_buffer_catc(&cpp->msg_buf, ch);
}


void cpp_msg_catn(CPP* cpp, const char* str, size_t len)
{
    cpp_buffer_catn(&cpp->msg_buf, str, len);
}


void cpp_msg_cats(CPP* cpp, const char* str)
{
    cpp_buffer_cats(&cpp->msg_buf, str);
}


void cpp_msg_cati(CPP* cpp, int number)
{
    char buffer[sizeof(number)*3+2];
    sprintf(buffer, "%d", number);
    cpp_buffer_cats(&cpp->msg_buf, buffer);
}


void cpp_msg_catfl(CPP* cpp, const char* file, int line)
{
    cpp_msg_cats(cpp, file);
    cpp_msg_cats(cpp, "(");
    cpp_msg_cati(cpp, line);
    cpp_msg_cats(cpp, ")");
}


const char* cpp_msg_gets(CPP* cpp)
{
    return cpp_buffer_gets(&cpp->msg_buf);
}
